

/* 
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/* ficher probecst.c
en passant par un fichier binaire intermediaire
ainsi les proc dump_inst() et atldumpprobes() sont utilises
*/
#include <stdio.h>
#include <string.h>
#ifdef USE_ATS
#undef USE_ATS
#endif
#define USE_ATS 1

#include "TP.h"
#include "probecst.h"

#define DIRSEPARATOR '/'
atl_declar;
unsigned char buffer[1024];
int atlRecCount;

static ATL_CTX_PRB atl_openFile(char *path,char *instance,char *mode)
{
char f[100];
int n;
ATL_CTX_PRB file;
  if((n=strlen(path)))
  {
    strcpy(f,path);
    f[n]=DIRSEPARATOR;
    n++;
  }
  strcpy(&f[n],instance);
  n+=strlen(instance);
  strcpy(&f[n],".rii");
#ifdef WIN32
 /*atl_set_clock ();*/
#endif
 file=fopen(f,mode);
return (file);
}

ATL_CTX_PRB atl_create_probe(char *path,char *instance,int p1)
{
  ATL_CTX_PRB f;
  f=atl_openFile(path,instance,"wb");
  atl_write_key(f,(unsigned int)-1,0); /* date the creation */ 
  return (f);
}

void atl_end_probe(ATL_CTX_PRB ctx)
{
fclose(ctx);
ctx=0;
}

void atl_write_probe(ATL_CTX_PRB ctx,unsigned int code, unsigned int key, void *msg, unsigned int lenmsg)
{
ATL_T_DATE time;
unsigned short scode,slen;
  if(ctx)
    {
	atlRecCount++;
	scode=code;
	slen=lenmsg;
	atl_get_date(&time);
	fwrite(&time,sizeof(ATL_T_DATE),1,ctx);
	fwrite(&scode,sizeof(unsigned short),1,ctx);
	fwrite(&slen,sizeof(unsigned short),1,ctx);
	fwrite(msg,slen,1,ctx);
    }
}

void atl_write_key(ATL_CTX_PRB ctx,unsigned int code,unsigned int value)
{
  unsigned int msg;;
  msg=value;
  atl_write_probe(ctx,code,0,&msg,sizeof(unsigned int));
  
}


/* return 1 if record exist
*/
int atl_read_probe(ATL_CTX_PRB ctx, ATL_T_DATE *time, unsigned int *code, unsigned int *key, void **msg)
{
unsigned short lenmsg;
unsigned short scode;
  fread(time,sizeof(ATL_T_DATE),1,ctx);
  if(feof(ctx)==0)
  { 
	fread(&scode,sizeof(unsigned short),1,ctx);
	*key=0;/*	fread(&skey,sizeof(unsigned short),1,ctx);*/
	fread(&lenmsg,sizeof(unsigned short),1,ctx);
	fread(buffer,lenmsg,1,ctx);
	*msg=buffer;
	*code=scode;
	return (1);
  }
  return (0);
}

/* gestion lecture */
ATL_CTX_PRB atl_open_probe(ATL_CTX_PRB prb_ctx, char *path,char *riofile, char *instance,int p1)
{
return (atl_openFile(path,instance,"rb"));
}

void atl_close_probe(ATL_CTX_PRB ctx)
{
fclose(ctx);
}
